    All Packages  Class Hierarchy  This Package  Previous  Next  Index

# Class java.text.BreakIterator

    java.lang.Object
       |
       +----java.text.BreakIterator

public abstract class BreakIterator
extends Object
implements Cloneable, Serializable

The `BreakIterator` class implements methods for finding the location of boundaries in text. Instances of `BreakIterator` maintain a current position and scan over text returning the index of characters where boundaries occur. Internally, `BreakIterator` scans text using a `CharacterIterator`, and is thus able to scan text held by any object implementing that protocol. A `StringCharacterIterator` is used to scan `String` objects passed to `setText`.

You use the factory methods provided by this class to create instances of various types of break iterators. In particular, use `getWordIterator`, `getLineIterator`, `getSentenceIterator`, and `getCharacterIterator` to create `BreakIterator`s that perform word, line, sentence, and character boundary analysis respectively. A single `BreakIterator` can work only on one unit (word, line, sentence, and so on). You must use a different iterator for each unit boundary analysis you wish to perform.

Line boundary analysis determines where a text string can be broken when line-wrapping. The mechanism correctly handles punctuation and hyphenated words.

Sentence boundary analysis allows selection with correct interpretation of periods within numbers and abbreviations, and trailing punctuation marks such as quotation marks and parentheses.

Word boundary analysis is used by search and replace functions, as well as within text editing applications that allow the user to select words with a double click. Word selection provides correct interpretation of punctuation marks within and following words. Characters that are not part of a word, such as symbols or punctuation marks, have word-breaks on both sides.

Character boundary analysis allows users to interact with characters as they expect to, for example, when moving the cursor through a text string. Character boundary analysis provides correct navigation of through character strings, regardless of how the character is stored. For example, an accented character might be stored as a base character and a diacritical mark. What users consider to be a character can differ between languages.

`BreakIterator` is intended for use with natural languages only. Do not use this class to tokenize a programming language.

Examples:

Creating and using text boundaries

>      public static void main(String args[]) {
>           if (args.length == 1) {
>               String stringToExamine = args[0];
>               //print each word in order
>               BreakIterator boundary = BreakIterator.getWordInstance();
>               boundary.setText(stringToExamine);
>               printEachForward(boundary, stringToExamine);
>               //print each sentence in reverse order
>               boundary = BreakIterator.getSentenceInstance(Locale.US);
>               boundary.setText(stringToExamine);
>               printEachBackward(boundary, stringToExamine);
>               printFirst(boundary, stringToExamine);
>               printLast(boundary, stringToExamine);
>           }
>      }

Print each element in order

>      public static void printEachForward(BreakIterator boundary, String source) {
>          int start = boundary.first();
>          for (int end = boundary.next();
>               end != BreakIterator.DONE;
>               start = end, end = boundary.next()) {
>               System.out.println(source.substring(start,end));
>          }
>      }

Print each element in reverse order

>      public static void printEachBackward(BreakIterator boundary, String source) {
>          int end = boundary.last();
>          for (int start = boundary.previous();
>               start != BreakIterator.DONE;
>               end = start, start = boundary.previous()) {
>              System.out.println(source.substring(start,end));
>          }
>      }

Print first element

>      public static void printFirst(BreakIterator boundary, String source) {
>          int start = boundary.first();
>          int end = boundary.next();
>          System.out.println(source.substring(start,end));
>      }

Print last element

>      public static void printLast(BreakIterator boundary, String source) {
>          int end = boundary.last();
>          int start = boundary.previous();
>          System.out.println(source.substring(start,end));
>      }

Print the element at a specified position

>      public static void printAt(BreakIterator boundary, int pos, String source) {
>          int end = boundary.following(pos);
>          int start = boundary.previous();
>          System.out.println(source.substring(start,end));
>      }

See Also:
  CharacterIterator

##

DONE
  DONE is returned by previous() and next() after all valid boundaries have been returned.

##

BreakIterator()
  Constructor.

##

clone()
  Create a copy of this iterator
current()
  Return character index of the text boundary that was most recently returned by next(), previous(), first(), or last()
first()
  Return the first boundary.
following(int)
  Return the first boundary following the specified offset.
getAvailableLocales()
  Get the set of Locales for which BreakIterators are installed
getCharacterInstance()
  Create BreakIterator for character-breaks using default locale Returns an instance of a BreakIterator implementing character breaks.
getCharacterInstance(Locale)
  Create BreakIterator for character-breaks using specified locale Returns an instance of a BreakIterator implementing character breaks.
getLineInstance()
  Create BreakIterator for line-breaks using default locale.
getLineInstance(Locale)
  Create BreakIterator for line-breaks using specfied locale.
getSentenceInstance()
  Create BreakIterator for sentence-breaks using default locale Returns an instance of a BreakIterator implementing sentence breaks.
getSentenceInstance(Locale)
  Create BreakIterator for sentence-breaks using specified locale Returns an instance of a BreakIterator implementing sentence breaks.
getText()
  Get the text being scanned
getWordInstance()
  Create BreakIterator for word-breaks using default locale.
getWordInstance(Locale)
  Create BreakIterator for word-breaks using specified locale.
last()
  Return the last boundary.
next()
  Return the boundary following the current boundary.
next(int)
  Return the nth boundary from the current boundary
previous()
  Return the boundary preceding the current boundary.
setText(CharacterIterator)
  Set a new text for scanning.
setText(String)
  Set a new text string to be scanned.

##

DONE

     public static final int DONE

  DONE is returned by previous() and next() after all valid boundaries have been returned.

##

BreakIterator

     protected BreakIterator()

  Constructor. BreakIterator is stateless and has no default behavior.

##

clone

     public Object clone()

  Create a copy of this iterator

  Returns:
    A copy of this
  Overrides:
    clone in class Object

first

     public abstract int first()

  Return the first boundary. The iterator's current position is set to the first boundary.

  Returns:
    The character index of the first text boundary.

last

     public abstract int last()

  Return the last boundary. The iterator's current position is set to the last boundary.

  Returns:
    The character index of the last text boundary.

next

     public abstract int next(int n)

  Return the nth boundary from the current boundary

  Parameters:
    n - which boundary to return. A value of 0 does nothing. Negative values move to previous boundaries and positive values move to later boundaries.
  Returns:
    The index of the nth boundary from the current position.

next

     public abstract int next()

  Return the boundary following the current boundary.

  Returns:
    The character index of the next text boundary or DONE if all boundaries have been returned. Equivalent to next(1).

previous

     public abstract int previous()

  Return the boundary preceding the current boundary.

  Returns:
    The character index of the previous text boundary or DONE if all boundaries have been returned.

following

     public abstract int following(int offset)

  Return the first boundary following the specified offset. The value returned is always greater than the offset or the value BreakIterator.DONE

  Parameters:
    offset - the offset to begin scanning. Valid values are determined by the CharacterIterator passed to setText(). Invalid values cause an IllegalArgumentException to be thrown.
  Returns:
    The first boundary after the specified offset.

current

     public abstract int current()

  Return character index of the text boundary that was most recently returned by next(), previous(), first(), or last()

  Returns:
    The boundary most recently returned.

getText

     public abstract CharacterIterator getText()

  Get the text being scanned

  Returns:
    the text being scanned

setText

     public void setText(String newText)

  Set a new text string to be scanned. The current scan position is reset to first().

  Parameters:
    newText - new text to scan.

setText

     public abstract void setText(CharacterIterator newText)

  Set a new text for scanning. The current scan position is reset to first().

  Parameters:
    newText - new text to scan.

getWordInstance

     public static BreakIterator getWordInstance()

  Create BreakIterator for word-breaks using default locale. Returns an instance of a BreakIterator implementing word breaks. WordBreak is usefull for word selection (ex. double click)

  Returns:
    A BreakIterator for word-breaks
  See Also:
    getDefault

getWordInstance

     public static BreakIterator getWordInstance(Locale where)

  Create BreakIterator for word-breaks using specified locale. Returns an instance of a BreakIterator implementing word breaks. WordBreak is usefull for word selection (ex. double click)

  Parameters:
    where - the local. If a specific WordBreak is not avaliable for the specified locale, a default WordBreak is returned.
  Returns:
    A BreakIterator for word-breaks

getLineInstance

     public static BreakIterator getLineInstance()

  Create BreakIterator for line-breaks using default locale. Returns an instance of a BreakIterator implementing line breaks. Line breaks are logically possible line breaks, actual line breaks are usually determined based on display width. LineBreak is useful for word wrapping text.

  Returns:
    A BreakIterator for line-breaks
  See Also:
    getDefault

getLineInstance

     public static BreakIterator getLineInstance(Locale where)

  Create BreakIterator for line-breaks using specfied locale. Returns an instance of a BreakIterator implementing line breaks. Line breaks are logically possible line breaks, actual line breaks are usually determined based on display width. LineBreak is useful for word wrapping text.

  Parameters:
    where - the local. If a specific LineBreak is not avaliable for the specified locale, a default LineBreak is returned.
  Returns:
    A BreakIterator for line-breaks

getCharacterInstance

     public static BreakIterator getCharacterInstance()

  Create BreakIterator for character-breaks using default locale Returns an instance of a BreakIterator implementing character breaks. Character breaks are boundaries of combining character sequences.

  Returns:
    A BreakIterator for character-breaks
  See Also:
    getDefault

getCharacterInstance

     public static BreakIterator getCharacterInstance(Locale where)

  Create BreakIterator for character-breaks using specified locale Returns an instance of a BreakIterator implementing character breaks. Character breaks are boundaries of combining character sequences.

  Parameters:
    where - the local. If a specific character break is not avaliable for the specified local, a default character break is returned.
  Returns:
    A BreakIterator for character-breaks

getSentenceInstance

     public static BreakIterator getSentenceInstance()

  Create BreakIterator for sentence-breaks using default locale Returns an instance of a BreakIterator implementing sentence breaks.

  Returns:
    A BreakIterator for sentence-breaks
  See Also:
    getDefault

getSentenceInstance

     public static BreakIterator getSentenceInstance(Locale where)

  Create BreakIterator for sentence-breaks using specified locale Returns an instance of a BreakIterator implementing sentence breaks.

  Parameters:
    where - the local. If a specific SentenceBreak is not avaliable for the specified local, a default SentenceBreak is returned.
  Returns:
    A BreakIterator for sentence-breaks

getAvailableLocales

     public static synchronized Locale[] getAvailableLocales()

  Get the set of Locales for which BreakIterators are installed

  Returns:
    available locales

    All Packages  Class Hierarchy  This Package  Previous  Next  Index

Submit a bug or feature - Version 1.1.8 of Java Platform API Specification
Java is a trademark or registered trademark of Sun Microsystems, Inc. in the US and other countries.
Copyright 1995-1999 Sun Microsystems, Inc. 901 San Antonio Road,
Palo Alto, California, 94303, U.S.A. All Rights Reserved.